
package de.ivu.elect.presentation.wahl.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlterminSessionSelect;
import de.ivu.elect.business.wahl.entity.Wahltermin;
import de.ivu.elect.jee.faces.FacesContextUtil;
import de.ivu.elect.presentation.security.WahlterminZurBearbeitungAuswaehlen;

@Named(WahlterminZurBearbeitungAuswaehlenAction.COMPONENT_NAME)
public class WahlterminZurBearbeitungAuswaehlenAction extends AbstractWahlterminAction implements WahlterminZurBearbeitungAuswaehlen {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlterminZurBearbeitungAuswaehlenAction";

  @Inject
  private transient WahlterminSessionSelect wahlterminSessionSelect;

  @Override
  public boolean isDisabledInternal(@Nonnull Wahltermin entity) {
    return super.isDisabledInternal(entity) ||  isCurrentlySelectedWahltermin(entity) || !wahlterminSessionSelect.isSetzenErlaubt(attach(entity));
  }

  @Override
  public String doIt(Wahltermin entity) {
    setCurrentlySelectedWahltermin(entity);

    messages.addInfoMessage("wahltermin.edit.action.select.success.message", entity.getName());

    return getViewNachAuswahl();
  }

  protected String getViewNachAuswahl() {
    return FacesContextUtil.getCurrentViewId();
  }

  private boolean isCurrentlySelectedWahltermin(Wahltermin entity) {
    return wahlterminSessionSelect.isSelected() && wahlterminSessionSelect.getEntity().equals(entity);
  }

  public void setCurrentlySelectedWahltermin(Wahltermin entity) {
    wahlterminSessionSelect.setEntity(entity);
  }

  @Override
  public String getLabelKey() {
    return "wahltermin.edit.action.select";
  }

  @Override
  public String getIcon() {
    return "fa fa-thumb-tack";
  }

  @Override
  public UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLTERMIN_ZUR_BEARBEITUNG_AUSWAEHLEN;
  }

  @Override
  protected boolean isFireChangeEvent() {
    return true;
  }

  @Override
  protected void refreshViewOnNonBlankResult(Wahltermin entity, String result) {
    FacesContextUtil.redirectToViewNoRedirectParameter(result); // ELECTMUC-1552
  }

}
